Lorene::Diff Class Referenceabstract
General PDE solvers (<em><strong>under development</strong></em>)

Base (abstract) class for 1D spectral differential operators in one domain. More...

`#include <diff.h>`

Inheritance diagram for Lorene::Diff:

## Public Member Functions

int | get_base () const
| Returns the base on which the operator is defined.
int | get_npoints () const
| Returns the number of coefficients (size of the matrix).
| operator Matrice () const
| Conversion to a matrix.
virtual const Matrice & | get_matrice () const =0
| Returns the matrix associated with the operator.

## Static Public Attributes

static const int | max_points = 50
| Maximal number of matrices stored per base.

## Protected Member Functions

| Diff (int base_r, int nr)
| Standard constructor.
| Diff (const Diff &)
| Copy constructor.
virtual | ~Diff ()
| Destructor.
void | operator= (const Diff &)
| Assignment to another Diff.
virtual ostream & | operator>> (ostream &) const =0
| Operator >> (virtual function called by the operator <<).

## Protected Attributes

int | base
| Base in radial direction.
int | npoints
| Number of coefficients.

## Friends

ostream & | operator<< (ostream &ost, const Diff &ope)
| Display.

## Detailed Description

Base (abstract) class for 1D spectral differential operators in one domain.

()

This class is intended as a base class for several classes of elementary differential operators in term of , in a given domain. Their main purpose is to compute the matrix of the elementary operator, for the given spectral base and number of coefficients. Some of the operators are not defined in the shells (division by ).

Definition at line 65 of file diff.h.

## Constructor & Destructor Documentation

## Diff() [1/2]

Lorene::Diff::Diff | ( | int | base_r,
|  | int | nr )

protected

Standard constructor.

Definition at line 61 of file diff.C.

References base, MAX_BASE, npoints, and TRA_R.

## Diff() [2/2]

Lorene::Diff::Diff | ( | const Diff & | diff_in | ) |

protected

Copy constructor.

Definition at line 67 of file diff.C.

References base, Diff(), MAX_BASE, and npoints.

## ~Diff()

Lorene::Diff::~Diff | ( |  | ) |

protected virtual

Destructor.

Definition at line 73 of file diff.C.

## Member Function Documentation

## get_base()

int Lorene::Diff::get_base | ( |  | ) | const

inline

Returns the base on which the operator is defined.

Definition at line 96 of file diff.h.

References base.

## get_matrice()

virtual const Matrice & Lorene::Diff::get_matrice | ( |  | ) | const

pure virtual

Returns the matrix associated with the operator.

Implemented in Lorene::Diff_dsdx2, Lorene::Diff_dsdx, Lorene::Diff_id, Lorene::Diff_mx2, Lorene::Diff_mx, Lorene::Diff_sx2, Lorene::Diff_sx, Lorene::Diff_sxdsdx, Lorene::Diff_x2dsdx2, Lorene::Diff_x2dsdx, Lorene::Diff_x3dsdx2, Lorene::Diff_x3dsdx, Lorene::Diff_x4dsdx2, Lorene::Diff_xdsdx2, and Lorene::Diff_xdsdx.

References Diff().

## get_npoints()

int Lorene::Diff::get_npoints | ( |  | ) | const

inline

Returns the number of coefficients (size of the matrix).

Definition at line 99 of file diff.h.

References npoints.

## operator Matrice()

Lorene::Diff::operator Matrice | ( |  | ) | const

inline

Conversion to a matrix.

Definition at line 102 of file diff.h.

References get_matrice().

## operator=()

void Lorene::Diff::operator= | ( | const Diff & | diff_in | ) |

protected

Assignment to another Diff.

Definition at line 75 of file diff.C.

References base, Diff(), MAX_BASE, and npoints.

## operator>>()

virtual ostream & Lorene::Diff::operator>> | ( | ostream & |  | ) | const

protected pure virtual

Operator >> (virtual function called by the operator <<).

Implemented in Lorene::Diff_dsdx2, Lorene::Diff_dsdx, Lorene::Diff_id, Lorene::Diff_mx2, Lorene::Diff_mx, Lorene::Diff_sx2, Lorene::Diff_sx, Lorene::Diff_sxdsdx, Lorene::Diff_x2dsdx2, Lorene::Diff_x2dsdx, Lorene::Diff_x3dsdx2, Lorene::Diff_x3dsdx, Lorene::Diff_x4dsdx2, Lorene::Diff_xdsdx2, and Lorene::Diff_xdsdx.

## Friends And Related Symbol Documentation

## operator<<

ostream & operator<< | ( | ostream & | ost,
|  | const Diff & | ope )

friend

Display.

Definition at line 83 of file diff.C.

References base, Diff(), npoints, operator<<, R_CHEB, R_CHEBI, R_CHEBP, R_CHEBU, R_JACO02, and TRA_R.

## Member Data Documentation

## base

int Lorene::Diff::base

protected

Base in radial direction.

Definition at line 74 of file diff.h.

## max_points

const int Lorene::Diff::max_points = 50

static

Maximal number of matrices stored per base.

Definition at line 71 of file diff.h.

## npoints

int Lorene::Diff::npoints

protected

Number of coefficients.

Definition at line 75 of file diff.h.

The documentation for this class was generated from the following files:

- diff.h
- diff.C